## stress-ng 0.20.00

=== Makefile ===
#
# Copyright (C) 2013-2021 Canonical, Ltd.
# Copyright (C) 2021-2026 Colin Ian King
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#

#
# Codename "versatile vma vexer"
#
VERSION=0.20.00

#
# Determine supported toolchains
#
COMPILER = cc
ifneq ($(shell $(CC) -v 2>&1 | grep "^icc version"),)
COMPILER = icc
endif
ifneq ($(shell $(CC) -v 2>&1 | grep version | grep "^gcc"),)
COMPILER = gcc
endif
ifneq ($(shell $(CC) -v 2>&1 | grep "Portable C Compiler"),)
COMPILER = pcc
endif
ifneq ($(shell $(CC) -v 2>&1 | grep "tcc"),)
COMPILER = tcc
endif
ifneq ($(shell $(CC) -v 2>&1 | grep version | grep clang),)
COMPILER = clang
endif
ifneq ($(shell $(CC) -v 2>&1 | grep oneAPI | grep Compiler),)
COMPILER = icx
endif
ifeq ($(shell echo | $(CC) -E -Wp,-v - 2>&1 | grep musl  > /dev/null && echo 1),1)
COMPILER = musl-gcc
override CFLAGS += -DHAVE_CC_MUSL_GCC
endif
ifneq ($(shell $(CC) -v 2>&1 | grep scan-build),)
COMPILER = scan-build
override CC := $(CC) clang
endif

#
# check for ALT linux gcc, define HAVE_ALT_LINUX_GCC, see core-shim.c
# https://github.com/ColinIanKing/stress-ng/issues/452
#
ifneq ($(shell $(CC) -v 2>&1 | grep Target | grep "alt-linux"),)
override CFLAGS += -DHAVE_ALT_LINUX_GCC
endif

KERNEL=$(shell uname -s)
NODENAME=$(shell uname -n)

override CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"'

#
#  Building stress-vnni with less than -O2 causes breakage with
#  gcc-13.2, so remove then and ensure at least -O2 is used or
#  honour flags > -O2 if they are provided
#
VNNI_OFLAGS_REMOVE=-O0 -O1 -Os -Oz -Og
VNNI_CFLAGS += $(filter-out $(VNNI_OFLAGS_REMOVE),$(CFLAGS))

#
# Default -O2 if optimization level not defined
#
ifeq "$(findstring -O,$(CFLAGS))" ""
	override CFLAGS += -O2
endif
ifeq "$(findstring -O,$(VNNI_CFLAGS))" ""
	override VNNI_CFLAGS += -O2
endif

#
# Debug flag
#
ifeq ($(DEBUG),1)
override CFLAGS += -g
endif

#
# Check if compiler supports flag set in $(flag)
#
cc_supports_flag = $(shell $(CC) -Werror $(flag) -E -xc /dev/null > /dev/null 2>&1 && echo $(flag))

#
# Pedantic flags
#
ifeq ($(PEDANTIC),1)
ifeq ($(COMPILER),icc)
PEDANTIC_FLAGS := \
	-Wcast-qual -Wfloat-equal -Wmissing-declarations \
	-Wno-long-long -Wshadow -Wno-missing-field-initializers \
	-Wno-missing-braces -Wno-sign-compare -Wno-multichar \
	-DHAVE_PEDANTIC
else
PEDANTIC_FLAGS := \
	-Wcast-qual -Wfloat-equal -Wmissing-declarations \
	-Wmissing-format-attribute -Wno-long-long -Wpacked \
	-Wredundant-decls -Wshadow -Wno-missing-field-initializers \
	-Wno-missing-braces -Wno-sign-compare -Wno-multichar \
	-Warray-bounds=2 -Wstringop-overflow -Wformat-overflow \
	-Wmaybe-uninitialized -Wshadow -Wdouble-promotion \
	-Wcast-align=strict -Wduplicated-cond \
	-Wduplicated-branches \
	-DHAVE_PEDANTIC
endif
override CFLAGS += $(foreach flag,$(PEDANTIC_FLAGS),$(cc_supports_flag))
endif

#
# Sanitize flags
#
ifeq ($(SANITIZE),1)
SANITIZE_FLAGS := \
	-fsanitize=null -fsanitize=bounds-strict -fsanitize=bounds \
	-fsanitize=object-size -fsanitize=pointer-overflow -fsanitize=builtin \
	-fsanitize=alignment -fsanitize=object-size
override CFLAGS += $(foreach flag,$(SANITIZE_FLAGS),$(cc_supports_flag))
endif

#
# Test for hardening flags and apply them if applicable
#
MACHINE := $(shell make -f Makefile.machine)
ifneq ($(PRESERVE_CFLAGS),1)
ifneq ($(MACHINE),$(filter $(MACHINE),alpha hppa ia64))
flag = -Wformat -fstack-protector-strong -Werror=format-security
#
# add -D_FORTIFY_SOURCE=2 if _FORTIFY_SOURCE is not already defined
#
ifeq ($(shell echo _FORTIFY_SOURCE | $(CC) $(CFLAGS) -E -xc - | tail -1),_FORTIFY_SOURCE)
flag += -D_FORTIFY_SOURCE=2
endif
override CFLAGS += $(cc_supports_flag)
endif
endif

#
# Optimization flags
#
ifneq ($(filter-out clang icc scan-build,$(COMPILER)),)
override CFLAGS += $(foreach flag,-fipa-pta -fivopts,$(cc_supports_flag))
override CFLAGS += $(foreach flag,-ftree-vectorize -ftree-slp-vectorize,$(cc_supports_flag))
ifeq ($(filter $(MACHINE),ibms390 s390),)
override CFLAGS += $(foreach flag,-fmodulo-sched,$(cc_supports_flag))
endif
endif

#
# Relax compxchg flags
#
ifneq ($(filter-out clang icc pcc scan-build,$(COMPILER)),)
override CFLAGS += $(foreach flag,-mrelax-cmpxchg-loop,$(cc_supports_flag))
endif

ifeq ($(COMPILER),icx)
override CFLAGS += -vec -ax
endif


#
# Enable Link Time Optimization
#
ifeq ($(LTO),1)
override CFLAGS += $(foreach flag,-flto=auto,$(cc_supports_flag))
endif

ifeq ($(GARBAGE_COLLECT),1)
#
# Sections flags
#
SECTIONS_FLAGS := -ffunction-sections -fdata-sections -Wl,--gc-sections
override CFLAGS += $(foreach flag,$(SECTIONS_FLAGS),$(cc_supports_flag))

ifneq ($(VERBOSE),)
GC_SECTIONS_FLAGS := -Wl,--print-gc-sections
override CFLAGS += $(foreach flag,$(GC_SECTIONS_FLAGS),$(cc_supports_flag))
endif
endif

ifneq ($(SOURCE_DATE_EPOCH),)
override CFLAGS += -DHAVE_SOURCE_DATE_EPOCH=$(SOURCE_DATE_EPOCH)
endif

ifneq ($(EXTRA_BUILDINFO),)
override CFLAGS += -DHAVE_EXTRA_BUILDINFO
endif

#
# Expected build warnings
#
ifeq ($(UNEXPECTED),1)
override CFLAGS += -DCHECK_UNEXPECTED
endif

#
# Building with Coverity?
#
ifeq ($(COVERITY),1)
override CFLAGS += -DCOVERITY
endif

#
# Building in github?
#
ifneq ($(GITHUB_RUN_ATTEMPT),)
override VERBOSE=1
endif

#
# Disable any user defined PREFV setting
#
ifneq ($(PRE_V),)
override undefine PRE_V
endif
#
# Verbosity prefixes
#
ifeq ($(VERBOSE),)
PRE_V=@
PRE_Q=@
else
PRE_V=
PRE_Q=@#
endif

ifneq ($(PRESERVE_CFLAGS),1)
ifeq ($(findstring icc,$(COMPILER)),icc)
override CFLAGS += -no-inline-max-size -no-inline-max-total-size
override CFLAGS += -axAVX,CORE-AVX2,CORE-AVX-I,CORE-AVX512,SSE2,SSE3,SSSE3,SSE4.1,SSE4.2,SANDYBRIDGE,SKYLAKE,SKYLAKE-AVX512,TIGERLAKE,SAPPHIRERAPIDS
override CFLAGS += -ip -falign-loops -funroll-loops -ansi-alias -fma -qoverride-limits
endif
endif

#ifeq ($(findstring clang,$(COMPILER)),clang)
#override CFLAGS += -Weverything
#endif

GREP = grep
#
# SunOS requires special grep for -e support
#
ifeq ($(KERNEL),SunOS)
ifneq ($(NODENAME),dilos)
GREP = /usr/xpg4/bin/grep
endif
endif

#
# Static flags, only to be used when using GCC
#
ifeq ($(STATIC),1)
override LDFLAGS += -static -z muldefs -ffunction-sections -fdata-sections -Wl,--gc-sections
override CFLAGS += -DBUILD_STATIC
endif

#
# Finalize flags
#

override CXXFLAGS += $(CFLAGS)

override CXXFLAGS := $(CXXFLAGS)
override CPPFLAGS := $(CPPFLAGS)
override LDFLAGS := $(LDFLAGS)
override VNNI_CFLAGS := $(VNNI_CFLAGS)
override CFLAGS := $(CFLAGS) -std=gnu99

BINDIR=/usr/bin
MANDIR=/usr/share/man/man1
JOBDIR=/usr/share/stress-ng/example-jobs
BASHDIR=/usr/share/bash-completion/completions

#
# Header files
#
HEADERS = \
	core-arch.h \
	core-affinity.h \
	core-asm-arm.h \
	core-asm-generic.h \
	core-asm-loong64.h \
	core-asm-ppc64.h \
	core-asm-riscv.h \
	core-asm-s390.h \
	core-asm-sparc.h \
	core-asm-x86.h \
	core-asm-ret.h \
	core-attribute.h \
	core-bitops.h \
	core-builtin.h \
	core-capabilities.h \
	core-clocksource.h \
	core-config-check.h \
	core-cpu.h \
	core-cpu-cache.h \
	core-cpu-freq.h \
	core-cpuidle.h \
	core-filesystem.h \
	core-ftrace.h \
	core-hash.h \
	core-ignite-cpu.h \
	core-interrupts.h \
	core-io-priority.h \
	core-job.h \
	core-helper.h \
	core-killpid.h \
	core-klog.h \
	core-limit.h \
	core-lock.h \
	core-log.h \
	core-madvise.h \
	core-memory.h \
	core-mlock.h \
	core-mmap.h \
	core-mincore.h \
	core-module.h \
	core-mounts.h \
	core-mwc.h \
	core-nt-load.h \
	core-nt-store.h \
	core-net.h \
	core-numa.h \
	core-opts.h \
	core-out-of-memory.h \
	core-parse-opts.h \
	core-perf.h \
	core-pragma.h \
	core-prime.h \
	core-processes.h \
	core-pthread.h \
	core-put.h \
	core-rapl.h \
	core-resctrl.h \
	core-resources.h \
	core-sched.h \
	core-setting.h \
	core-shared-cache.h \
	core-shared-heap.h \
	core-shim.h \
	core-signal.h \
	core-smart.h \
	core-sort.h \
	core-stack.h \
	core-stressors.h \
	core-sync.h \
	core-syslog.h \
	core-target-clones.h \
	core-thermal-zone.h \
	core-thrash.h \
	core-time.h \
	core-try-open.h \
	core-vecmath.h \
	core-version.h \
	core-vmstat.h \
	core-workload.h \
	stress-af-alg-defconfigs.h \
	stress-eigen-ops.h \
	stress-ng.h

#
#  Build time generated header files
#
HEADERS_GEN = \
	config.h \
	git-commit-id.h \
	io-uring.h \
	personality.h

#
# Stress core
#
CORE_SRC = \
	core-affinity.c \
	core-arch.c \
	core-asm-ret.c \
	core-capabilities.c \
	core-cpu.c \
	core-cpu-cache.c \
	core-cpu-freq.c \
	core-cpuidle.c \
	core-clocksource.c \
	core-config-check.c \
	core-filesystem.c \
	core-hash.c \
	core-helper.c \
	core-ignite-cpu.c \
	core-interrupts.c \
	core-io-uring.c \
	core-io-priority.c \
	core-job.c \
	core-killpid.c \
	core-klog.c \
	core-limit.c \
	core-lock.c \
	core-log.c \
	core-madvise.c \
	core-memory.c \
	core-mincore.c \
	core-mlock.c \
	core-mmap.c \
	core-module.c \
	core-mounts.c \
	core-mwc.c \
	core-net.c \
	core-numa.c \
	core-opts.c \
	core-out-of-memory.c \
	core-parse-opts.c \
	core-perf.c \
	core-prime.c \
	core-processes.c \
	core-rapl.c \
	core-resctrl.c \
	core-resources.c \
	core-sched.c \
	core-setting.c \
	core-shared-cache.c \
	core-shared-heap.c \
	core-shim.c \
	core-signal.c \
	core-smart.c \
	core-sort.c \
	core-stack.c \
	core-sync.c \
	core-thermal-zone.c \
	core-time.c \
	core-thrash.c \
	core-ftrace.c \
	core-try-open.c \
	core-vmstat.c \
	core-workload.c \
	stress-ng.c

#
#  Build time core source files
#
CORE_SRC_GEN = \
	core-config.c

#
#  Stressors
#
STRESS_SRC = \
	stress-access.c \
	stress-acl.c \
	stress-affinity.c \
	stress-af-alg.c \
	stress-aio.c \
	stress-aiol.c \
	stress-alarm.c \
	stress-apparmor.c \
	stress-atomic.c \
	stress-bad-altstack.c \
	stress-bad-ioctl.c \
	stress-besselmath.c \
	stress-bigheap.c \
	stress-bind-mount.c \
	stress-binderfs.c \
	stress-bitonicsort.c \
	stress-bitops.c \
	stress-branch.c \
	stress-brk.c \
	stress-bsearch.c \
	stress-bubblesort.c \
	stress-cache.c \
	stress-cachehammer.c \
	stress-cacheline.c \
	stress-cap.c \
	stress-cgroup.c \
	stress-chattr.c \
	stress-chdir.c \
	stress-chmod.c \
	stress-chown.c \
	stress-chroot.c \
	stress-chyperbolic.c \
	stress-clock.c \
	stress-clone.c \
	stress-close.c \
	stress-context.c \
	stress-copy-file.c \
	stress-cpu.c \
	stress-cpu-online.c \
	stress-cpu-sched.c \
	stress-crypt.c \
	stress-ctrig.c \
	stress-cyclic.c \
	stress-daemon.c \
	stress-dccp.c \
	stress-dekker.c \
	stress-dentry.c \
	stress-dev.c \
	stress-dev-shm.c \
	stress-dfp.c \
	stress-dir.c \
	stress-dirdeep.c \
	stress-dirmany.c \
	stress-dnotify.c \
	stress-dup.c \
	stress-dynlib.c \
	stress-easy-opcode.c \
	stress-eigen.c \
	stress-efivar.c \
	stress-enosys.c \
	stress-env.c \
	stress-epoll.c \
	stress-eventfd.c \
	stress-exec.c \
	stress-exit-group.c \
	stress-expmath.c \
	stress-factor.c \
	stress-fallocate.c \
	stress-fanotify.c \
	stress-far-branch.c \
	stress-fault.c \
	stress-fcntl.c \
	stress-fd-abuse.c \
	stress-fd-fork.c \
	stress-fd-race.c \
	stress-fibsearch.c \
	stress-fiemap.c \
	stress-fifo.c \
	stress-file-ioctl.c \
	stress-filename.c \
	stress-filerace.c \
	stress-flipflop.c \
	stress-flock.c \
	stress-flushcache.c \
	stress-fma.c \
	stress-fork.c \
	stress-forkheavy.c \
	stress-fp.c \
	stress-fp-error.c \
	stress-fpunch.c \
	stress-fractal.c \
	stress-fsize.c \
	stress-fstat.c \
	stress-full.c \
	stress-funccall.c \
	stress-funcret.c \
	stress-futex.c \
	stress-get.c \
	stress-getrandom.c \
	stress-getdent.c \
	stress-goto.c \
	stress-gpu.c \

=== debian/changelog ===
stress-ng (0.20.00-1) unstable; urgency=medium

  * Sync to upstream version 0.20.00

 -- Colin Ian King <colin.i.king@gmail.com>  Wed, 31 Dec 2025 22:51:22 +0000

=== debian/control ===
Source: stress-ng
Rules-Requires-Root: no
Section: devel
Priority: optional
Maintainer: Colin Ian King <colin.i.king@gmail.com>
Standards-Version: 4.7.3
Build-Depends: debhelper (>= 13),
               debhelper-compat (=13),
               libacl1-dev,
               zlib1g-dev,
               libbsd-dev,
               libeigen3-dev,
               libcrypt-dev,
               libjpeg-dev,
               libmpfr-dev,
               libgmp-dev,
               libkeyutils-dev [linux-any],
               libapparmor-dev [linux-any],
               apparmor [linux-any],
               libaio-dev [linux-any],
               libcap-dev [linux-any],
               libsctp-dev [linux-any],
               libjudy-dev,
               libatomic1 [linux-any],
               libkmod-dev [linux-any],
               libxxhash-dev,
               libglvnd-dev,
               libgbm-dev [linux-any],
	       liblzma-dev
Homepage: https://github.com/ColinIanKing/stress-ng

Package: stress-ng
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: tool to load and stress a computer
 stress-ng can stress various subsystems of a computer.  It can stress load
 CPU, cache, disk, memory, socket and pipe I/O, scheduling and much more.
 stress-ng is a re-write of the original stress tool by Amos Waterland but
 has many additional features such as specifying the number of bogo operations
 to run, execution metrics, a stress verification on memory and compute
 operations and considerably more stress mechanisms.

## stress-ng 0.20.01

=== Makefile ===
--- 
+++ 
@@ -18,9 +18,9 @@
 #
 
 #
-# Codename "versatile vma vexer"
-#
-VERSION=0.20.00
+# Codename "malevolent memory masher"
+#
+VERSION=0.20.01
 
 #
 # Determine supported toolchains

=== debian/changelog ===
stress-ng (0.20.01-1) unstable; urgency=medium

  * Sync to upstream version 0.20.01

 -- Colin Ian King <colin.i.king@gmail.com>  Fri, 20 Feb 2026 17:17:17 +0000

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
DPKG_EXPORT_BUILDTOOLS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/buildtools.mk

override_dh_auto_build:
	$(shell dpkg-buildflags --export=sh); dh_auto_build -- $(if $(filter terse,$(DEB_BUILD_OPTIONS)),,VERBOSE=1)

override_dh_dwz:

%:
	dh $@
